' ********** Copyright 2018 Roku, Inc.  All Rights Reserved. **********
function RAFX_getSSAIPluginBase(params as object) as Object
daisdk = {}
daisdk.init = function(params=invalid as object) as Void
m.createImpl()
m.createEventCallbacks()
m.updateLocale()
m.logLevel = 0
if invalid <> params
if invalid <> params["logLevel"] then m.logLevel = params.logLevel
end if
end function
daisdk.requestStream = function(requestObj as object) as object
status = {}
ret = m.impl.requestPreplay(requestObj)
if ret <> invalid and ret["error"] <> invalid
status["error"] = ret["error"]
end if
return status
end function
daisdk.getStreamInfo = function() as object
return m.impl.getStreamInfo()
end function
daisdk.setStreamInfo = function(streamInfo as object) as object
return m.impl.setStreamInfo(streamInfo)
end function
daisdk.enableAds = function(params as object) as void
m.impl.enableAds(params)
end function
daisdk.addEventListener = function(event as string, callback as function) as Void
m.eventCallbacks.addEventListener(event, callback)
end function
daisdk.onMessage = function(msg as object) as object
return m.impl.onMessage(msg)
end function
daisdk.onSeekSnap = function(seekRequest as object) as double
return m.impl.onSeekSnap(seekRequest)
end function
daisdk.createEventCallbacks = function() as object
obj = m.createDAIObject("eventCallbacks")
obj.callbacks = {}
return obj
end function
evtcll = {}
evtcll.addEventListener = function(event as string, callback as function) as Void
m.callbacks[event] = callback
end function
evtcll.doCall = function(event as string, adInfo as object) as Void
if invalid <> m.callbacks[event]
func = getglobalaa()["callFunctionInGlobalNamespace"]
func(m.callbacks[event], adInfo)
end if
end function
evtcll.errCall = function(errid as integer, errInfo as string) as Void
ERROR = m.sdk.CreateError()
ERROR.id = errid
ERROR.info = errInfo
dd = getglobalaa()["callFunctionInGlobalNamespace"]
dd(m.sdk.AdEvent.ERROR, ERROR)
end function
daisdk["eventCallbacks"] = evtcll
daisdk.createImpl = function() as object
obj = m.createDAIObject("impl")
obj.strmURL = ""
obj.prplyInfo = invalid
obj.wrpdPlayer = invalid
obj.loader = invalid
obj.streamManager = invalid
obj.useStitched = true  
adIface = m.getRokuAds()
adIface.stitchedAdsInit([])
return obj
end function
impl = {}
impl.setStreamInfo = function(streamInfo as object) as void
end function
impl.parsePrplyInfo = function() as object
m.sdk.log("parsePrplyInfo() To be overridden")
return {adOpportunities:0, adBreaks:[]}
end function
impl.enableAds = function(params as object) as Void
ei = false
if type(params["player"]) = "roAssociativeArray"
player = params["player"]
if player.doesexist("port") and player.doesexist("sgnode")
ei = true
end if
m.wrpdPlayer = player
end if
m.useStitched = (invalid = params["useStitched"]  or  params["useStitched"])
if not ei
m.sdk.log("Warning: Invalid object for interactive ads.")
return
end if
m.setRAFAdPods(params["ads"])
end function
impl.setRAFAdPods = function(adbreaksGiven = invalid as object) as Void
adBreaks = adbreaksGiven
if invalid = adbreaksGiven
pTimer = createObject("roTimespan")
parseResults = m.parsePrplyInfo()
adBreaks = parseResults.adBreaks
if m.loader["xResponseTime"] <> invalid
m.sdk.logToRAF("ValidResponse", {ads:adBreaks,slots:parseResults.adOpportunities,responseTime:m.loader.xResponseTime, parseTime:pTimer.totalMilliseconds(), url:m.loader.strmURL, adServers:invalid})
m.loader.xResponseTime = invalid
end if
end if
if 0 < adBreaks.count()
if m.useStitched
adIface = m.sdk.getRokuAds()
adIface.stitchedAdsInit(adBreaks)
m.sdk.log(["impl.setRAFAdPods() adBreaks set to RAF. renderTime: ",adBreaks[0].renderTime.tostr()], 5)
end if
m.sdk.eventCallbacks.doCall(m.sdk.AdEvent.PODS, {event:m.sdk.AdEvent.PODS, adPods:adBreaks})
end if
if invalid = m.streamManager then m.streamManager = m.sdk.createStreamManager()
m.streamManager.createTimeToEventMap(adBreaks)
end function
impl.onMetadata = function(msg as object) as void
end function
impl.onPosition = function (msg as object) as void
m.streamManager.onPosition(msg)
end function
impl.onMessage = function(msg as object) as object
msgType = m.sdk.getMsgType(msg, m.wrpdPlayer)
if msgType = m.sdk.msgType.FINISHED     
m.sdk.log("All video is completed - full result")
m.sdk.eventCallbacks.doCall(m.sdk.AdEvent.STREAM_END, {})
else if msgType = m.sdk.msgType.METADATA
m.onMetadata(msg)
else if msgType = m.sdk.msgType.POSITION
m.onPosition(msg)
end if
curAd = m.msgToRAF(msg)
if invalid <> m.prplyInfo and msgType = m.sdk.msgType.POSITION
m.streamManager.onMessageVOD(msg, curAd)
m.onMessageLIVE(msg, curAd)
end if
return curAd
end function
impl.onSeekSnap = function(seekRequest as object) as double
if invalid = m.prplyInfo or m.prplyInfo.strmType <> m.sdk.StreamType.VOD or invalid = m.streamManager then return seekRequest.time
return m.streamManager.onSeekSnap(seekRequest)
end function
impl.onMessageLIVE = function(msg as object, curAd as object) as void
if m.sdk.StreamType.LIVE <> m.prplyInfo.strmType then return
end function
impl.msgToRAF = function(msg as object) as object
if m.useStitched
adIface = m.sdk.getRokuAds()
return adIface.stitchedAdHandledEvent(msg, m.wrpdPlayer)
end if
return invalid
end function
impl.requestPreplay = function(requestObj as object) as object
ret = {}
if invalid = m.loader
m.loader = m.createLoader(requestObj.type)
end if
jsn = m.loader.requestPreplay(requestObj)
if type(jsn) = "roAssociativeArray"
m.prplyInfo = jsn
else if jsn <> ""
m.prplyInfo = parsejson(jsn)
end if
if m.prplyInfo <> invalid
if requestObj["testAds"] <> invalid
ads = ReadAsciiFile(requestObj.testAds)
if ads <> invalid
m.prplyInfo.ads = parsejson(ads)
else
m.sdk.log(requestObj.testAds + " may not be valid JSON")
end if
end if
m.prplyInfo["strmType"] = requestObj.type
m.loader.composePingURL(m.prplyInfo)
else
m.prplyInfo = {strmType:requestObj.type}
ret["error"] = "No valid response from "+requestObj.url
end if
return ret
end function
impl.createLoader = function(live_or_vod as string) as object
m.loader = m.sdk.createLoader(live_or_vod)
return m.loader
end function
daisdk["impl"] = impl
daisdk.createLoader = function(live_or_vod as string) as object
obj = m.createDAIObject(live_or_vod+"loader")
obj.strmURL = ""
return obj
end function
liveloader = {}
liveloader.ping = function(param as dynamic) as void
m.sdk.log("liveloader.ping() To be overridden")
end function
daisdk["liveloader"] = liveloader
vodloader = {}
vodloader.ping = function(param as dynamic) as void
end function
vodloader.composePingURL = function(prplyInfo as object) as void
end function
vodloader.requestPreplay = function(requestObj as object) as dynamic
if not m.isValidString(m.strmURL)
m.strmURL = requestObj.url
end if
return m.getJSON({url:m.strmURL, retry:0})
end function
vodloader.isValidString = function(ue as dynamic) as boolean
ve = type(ue)
if ve = "roString" or ve = "String"
return len(ue) > 0
end if
return false
end function
vodloader.getJSON = function(params as object) as string
xfer = m.sdk.createUrlXfer(m.sdk.httpsRegex.isMatch(params.url))
xfer.setUrl(params.url)
port = createObject("roMessagePort")
xfer.setPort(port)
xfer.addHeader("Accept", "application/json, application/xml")
if invalid <> params["headers"]
for each item in params["headers"].items()
xfer.addHeader(item.key, item.value)
end for
end if
xTimer = createObject("roTimespan")
if params["retry"] <> invalid then m.sdk.logToRAF("Request", params)
xTimer.mark()
if invalid <> params["body"]
xfer.asyncPostFromString(params.body)
else
xfer.asyncGetToString()
end if
msg = port.waitMessage(4000)
xTime = xTimer.totalMilliseconds()
if msg = invalid
m.sdk.logToRAF("ErrorResponse", {error: "no response",
time: xTime, label: "Primary", url:params.url})
m.sdk.log("Msg is invalid. Possible timeout on loading URL")
return ""
else if type(msg) = "roUrlEvent"
wi = msg.getResponseCode()
if 200 <> wi and 201 <> wi
m.sdk.logToRAF("EmptyResponse", {error: msg.getfailurereason(),
time: xTime, label: "Primary", url:params.url})
m.sdk.log(["Transfer url: ", params.url, " failed, got code: ", wi.tostr(), " reason: ", msg.getfailurereason()])
return ""
end if
if params["retry"] <> invalid then m.xResponseTime = xTime
return msg.getString()
else
m.sdk.log("Unknown Ad Request Event: " + type(msg))
end if
return ""
end function
daisdk["vodloader"] = vodloader
daisdk.createStreamManager = function() as object
obj = m.createDAIObject("streamManager")
obj.adTimeToEventMap = invalid
obj.adTimeToBreakMap = invalid
obj.adTimeToBeginEnd = invalid
obj.cuePoints = invalid
obj.crrntPosSec = -1
obj.lastPosSec = -1
obj.whenAdBreakStart = -1 
obj.currentAdBreak = invalid
return obj
end function
strmMgr = {}
strmMgr.createTimeToEventMap = function(adBreaks as object) as Void
if adBreaks = invalid
m.adTimeToEventMap = invalid
m.adTimeToBreakMap = invalid
m.adTimeToBeginEnd = invalid
return
end if
timeToEvtMap = {}
timeToBreakMap = {}
timeToBeginEnd = []
for each adBreak in adBreaks
brkBegin = int(adBreak.renderTime)
brkTimeKey = brkBegin.tostr()
timeToEvtMap[brkTimeKey] = [m.sdk.AdEvent.POD_START]
timeToBreakMap[brkTimeKey] = adBreak
for each rAd in adBreak.ads
for each evt in rAd.tracking
if invalid <> evt["time"]
timeKey = int(evt.time).tostr()
if timeToEvtMap[timeKey] = invalid
timeToEvtMap[timeKey] = [evt.event]
else
eExist = false
for each e in timeToEvtMap[timeKey]
eExist =   eExist or (e = evt.event)
end for
if not eExist
timeToEvtMap[timeKey].push(evt.event)
end if
end if
end if
end for
end for
brkEnd = int(adBreak.renderTime+adBreak.duration)
timeKey = brkEnd.tostr()
m.appendBreakEnd(timeToEvtMap, timeKey)
timeToBeginEnd.push({"begin":brkBegin, "end":brkEnd, "renderSequence":adBreak.renderSequence})
end for
if not timeToEvtMap.isEmpty()
m.adTimeToEventMap = timeToEvtMap
m.lastEvents = {}
end if
if not timeToBreakMap.isEmpty() then m.adTimeToBreakMap = timeToBreakMap
if 0 < timeToBeginEnd.count() then
timeToBeginEnd.sortby("begin")
m.adTimeToBeginEnd = timeToBeginEnd
end if
end function
strmMgr.appendBreakEnd = function(timeToEvtMap as object, timeKey as string) as object
if timeToEvtMap[timeKey] = invalid
timeToEvtMap[timeKey] = [m.sdk.AdEvent.POD_END]
else
timeToEvtMap[timeKey].push(m.sdk.AdEvent.POD_END)
end if
return timeToEvtMap
end function
strmMgr.findBreak = function(possec as float) as object
snapbrk = invalid
if invalid = m.adTimeToBeginEnd then return snapbrk
for each brk in m.adTimeToBeginEnd
if  brk.begin <= possec  and  possec <= brk.end
snapbrk = brk
exit for
end if
if possec < brk.end then exit for
end for
return snapbrk
end function
strmMgr.onSeekSnap = function(seekRequest as object) as double
if invalid = m.adTimeToBeginEnd then return seekRequest.time
if m.sdk.SnapTo.NEXTPOD = seekRequest.snapto
for each brk in m.adTimeToBeginEnd
if seekRequest.time < brk.begin then
exit for
else if m.crrntPosSec <= brk.begin and brk.begin <= seekRequest.time
snap2begin = brk.begin - 1
if snap2begin < 0 then snap2begin = 0
return snap2begin
end if
end for
else
snapbrk = m.findBreak(seekRequest.time)
if snapbrk = invalid then return seekRequest.time
snap2begin = snapbrk.begin - 1
if snap2begin < 0 then snap2begin = 0
if "postroll" = snapbrk.renderSequence then return snap2begin
if m.sdk.SnapTo.BEGIN = seekRequest.snapto
return snap2begin
else if m.sdk.SnapTo.END = seekRequest.snapto
return snapbrk.end + 1
end if
end if
return seekRequest.time
end function
strmMgr.onPosition = function(msg as object) as Void
if m.currentAdBreak = invalid or m.currentAdBreak.duration = invalid
return
end if
posSec = msg.getData()
if 0 <= m.whenAdBreakStart and m.whenAdBreakStart + m.currentAdBreak.duration + 2 < posSec
m.cleanupAdBreakInfo()
end if
end function
strmMgr.onMessageVOD = function(msg as object, curAd as object) as Void
posSec = msg.getData()
if posSec = m.crrntPosSec or posSec = m.lastPosSec
return
end if
m.lastPosSec = m.crrntPosSec
m.crrntPosSec = posSec
if m.crrntPosSec <> m.lastPosSec + 1
m.handlePosition(posSec - 1, curAd)
end if
m.handlePosition(posSec, curAd)
end function
strmMgr.handlePosition = function(sec as integer, curAd as object) as Void
if m.adTimeToEventMap <> invalid
timeKey = sec.tostr()
if m.adTimeToEventMap[timeKey] <> invalid
for each adEvent in m.adTimeToEventMap[timeKey]
if adEvent <> invalid
m.handleAdEvent(adEvent, sec, curAd)
end if
end for
end if
end if
end function
strmMgr.fillAdBreakInfo = function(sec as integer, curAd as object) as Void
m.whenAdBreakStart = sec
if invalid <> m.adTimeToBreakMap
adBreak = m.adTimeToBreakMap[sec.tostr()]
if invalid <> adBreak
m.currentAdBreak = adBreak
end if
end if
end function
strmMgr.cleanupAdBreakInfo = function() as void
if m.currentAdBreak <> invalid
m.currentAdBreak.viewed = false
for each ad in m.currentAdBreak.ads
for each evnt in ad.tracking
evnt.triggered = false
end for
end for
end if
m.whenAdBreakStart = -1
m.currentAdBreak = invalid
m.lastEvents = {}
end function
strmMgr.handleAdEvent = function(adEvent as string, sec as integer, curAd as object) as Void
if adEvent = m.sdk.AdEvent.POD_START
m.fillAdBreakInfo(sec, curAd)
if m.lastEvents[adEvent] <> sec
m.lastEvents = {}
end if
else 
if invalid = m.currentAdBreak 
ab = m.findBreak(sec)
if invalid <> ab 
pastSec = ab.begin
while pastsec < sec
m.handlePosition(pastSec, curAd)
pastSec += 1
end while
end if
end if
end if
if m.lastEvents[adEvent] <> sec 
adInfo = {position:sec, event:adEvent}
if adEvent = m.sdk.AdEvent.POD_START then adInfo["adPod"] = m.currentAdBreak
m.sdk.eventCallbacks.doCall(adEvent, adInfo)
m.lastEvents[adEvent] = sec
end if
end function
strmMgr.pastLastAdBreak = function(posSec as integer) as boolean
return invalid = m.adTimeToBeginEnd  or  m.adTimeToBeginEnd.peek()["end"] < posSec
end function
daisdk["streamManager"] = strmMgr
daisdk.setCertificate = function(certificateRef as string) as Void
m.certificate = certificateRef
end function
daisdk.getCertificate = function() as string
if m.certificate = invalid
return "common:/certs/ca-bundle.crt"
end if
return m.certificate
end function
daisdk.getMsgType = function(msg as object, player as object) as integer
nodeId = player.sgnode.id
if "roSGNodeEvent" <> type(msg) or nodeId <> msg.getNode()
return m.msgType.UNKNOWN
end if
if type(msg) = "roSGNodeEvent"
xg = msg.getField()
if xg = "position"
return m.msgType.POSITION
else if xg.left(13) = "timedMetaData"
return m.msgType.METADATA
else if xg = "state"
if msg.getData() = "finished"
return m.msgType.FINISHED
end if
end if
end if
return m.msgType.UNKNOWN
end function
daisdk.createUrlXfer = function(ishttps as boolean) as object
xfer = createObject("roUrlTransfer")
if ishttps
xfer.setCertificatesfile(m.getCertificate())
xfer.initClientCertificates()
end if
xfer.addHeader("Accept-Language", m.locale.Accept_Language)
xfer.addHeader("Content-Language", m.locale.Content_Language)
return xfer
end function
daisdk.setTrackingTime = function(timeOffset as float, rAd as object) as void
duration = rAd.duration
for each evt in rAd.tracking
if evt.event = m.AdEvent.IMPRESSION
evt.time = 0.0 + timeOffset
else if evt.event = m.AdEvent.FIRST_QUARTILE
evt.time = duration * 0.25 + timeOffset
else if evt.event = m.AdEvent.MIDPOINT
evt.time = duration * 0.5 + timeOffset
else if evt.event = m.AdEvent.THIRD_QUARTILE
evt.time = duration * 0.75 + timeOffset
else if evt.event = m.AdEvent.COMPLETE
evt.time = duration + timeOffset
end if
end for
end function
daisdk.getValidStr = function(obj as object) as string
if invalid <> obj and invalid <> getInterface(obj, "ifString")
return obj.trim()
else
return ""
end if
end function
daisdk.httpsRegex = createObject("roRegEx", "^https", "")
daisdk.getRokuAds = function() as object
return roku_ads()
end function
daisdk.logToRAF = function(btype as string, obj as object) as object
m.getRokuAds().util.fireBeacon(btype, obj)
end function
daisdk.createDAIObject = function(objName as string) as object
if type(m[objName]) = "roAssociativeArray"
m[objName]["sdk"] = m
end if
return m[objName]
end function
daisdk.updateLocale = function()
m.locale.Content_Language = createObject("roDeviceInfo").getCurrentLocale().replace("_","-")
end function
daisdk.ErrorEvent = {
ERROR : "0",
COULD_NOT_LOAD_STREAM: "1000",
STREAM_API_KEY_NOT_VALID: "1002",
BAD_STREAM_REQUEST: "1003"
INVALID_RESPONSE: "1004"
}
daisdk.AdEvent = {
PODS: "PodsFound"
POD_START: "PodStart"
START: "Start",
IMPRESSION: "Impression",
CREATIVE_VIEW: "creativeView",
FIRST_QUARTILE: "FirstQuartile",
MIDPOINT: "Midpoint",
THIRD_QUARTILE: "ThirdQuartile",
COMPLETE: "Complete",
POD_END: "PodComplete",
STREAM_END: "StreamEnd",
ACCEPT_INVITATION: "AcceptInvitation",
ERROR: "Error"
}
daisdk.msgType = {
UNKNOWN: 0,
POSITION: 1,
METADATA: 2,
FINISHED: 3,
}
daisdk.version = {
ver: "0.1.0"
}
daisdk.locale = {
Accept_Language: "en-US,en-GB,es-ES,fr-CA,de-DE", 
Content_Language: "en-US" 
}
daisdk.StreamType = {
LIVE: "live",
VOD: "vod"
}
daisdk.SnapTo = {
NEXTPOD:  "nextpod", 
BEGIN: "begin",
END:   "end"
}
daisdk.CreateError = function() as object
ERROR = createObject("roAssociativeArray")
ERROR.id = ""
ERROR.info = ""
ERROR.type = "error"
return ERROR
end function
daisdk.log = function(x, logLevel=-1 as integer) as void
if logLevel < m.logLevel
dtm = ["SDK (", createObject("roDateTime").toISOString().split("T")[1], "): "].join("")
if "roArray" = type(x)
print dtm; x.join("")
else
print dtm; x
end if
end if
end function
getglobalaa()["callFunctionInGlobalNamespace"] = function(dd as function, ue as object) as Void
dd(ue)
end function
return daisdk
end function
function RAFX_getGglDAIAdapter(params as dynamic) as Object
rafssai = RAFX_getSSAIPluginBase(params)
rafssai.getRokuAds().getAds("")
impl = rafssai["impl"]
impl.getStreamInfo = function() as object
if m.prplyInfo <> invalid
return {
playURL: m.prplyInfo["stream_manifest"],
subtitles: m.prplyInfo["subtitles"],
stream_id: m.prplyInfo["stream_id"],
id3_events_url: m.prplyInfo["id3_events_url"], 
time_events_url: m.prplyInfo["time_events_url"]
}
end if
return {}
end function
impl.requestPreplayBase = impl.requestPreplay
impl.requestPreplay = function(requestObj as object) as object
ret = m.requestPreplayBase(requestObj)
if invalid <> m.prplyInfo
if invalid <>  m.prplyInfo["time_events_url"]
m.loader.ping({url:m.prplyInfo["time_events_url"]})
else if invalid <> m.prplyInfo["id3_events_url"]
m.loader.composePingURL(m.prplyInfo)
end if
end if
return ret
end function
impl.enableAdsBase = impl.enableAds
impl.enableAds = function(params as object) as Void
if invalid <> m.prplyInfo
if  invalid <> m.prplyInfo["time_events_url"]
m.parsePing()
else if invalid <> m.prplyInfo["id3_events_url"]  
player = params["player"]
hasSelected = false
skeys = []
for each key in player.sgnode.timedMetaDataSelectionKeys
if "TXXX" = key or "*" = key
hasSelected = true
end if
skeys.push(key)
end for
if not hasSelected 
skeys.push("TXXX")
player.sgnode.timedMetaDataSelectionKeys = skeys
end if
player.sgnode.observeField("timedMetaData",  player.port)
end if
end if
m.enableAdsBase(params)
end function
impl.onMetadata = function(msg as object) as void
if not m.useStitched then return
ret = m.streamManager.onMetadata(msg)
if invalid <> ret["pendingPod"]
pendingPod = ret["pendingPod"]
m.setRAFAdPods([pendingPod])
podBeginSec = int(pendingPod.renderTime)
while podBeginSec <= m.streamManager.crrntPosSec
m.streamManager.handlePosition(podBeginSec, {})
podBeginSec += 1
end while
end if
end function
impl.parsePrplyInfo = function() as object
if invalid <> m.prplyInfo
if invalid <> m.pingInfo and invalid <> m.pingInfo["ads"]
obj = m.ggl2raf(m.pingInfo)
m.pingInfo = invalid
if 0 = obj["adBreaks"].count() or invalid <> m.prplyInfo["time_events_url"] then return obj
m.streamManager.addPendingPods(obj["adBreaks"])
end if
end if
return {adOpportunities:0, adBreaks:[]}
end function
impl.ggl2raf = function(adMetadata as object) as object
adOpportunities = 0
adCount = 0  
for each item in adMetadata["breaks"].items()
ab = item.value
ab["viewed"] = false
ab["renderTime"] = 0.0
ab["renderSequence"] = ab["type"] + "roll"
ab["tracking"] = []
ab["adCount"] = ab["ads"]
ab.ads = createObject("roArray", ab.ads, true)
ab.delete("type")
end for
if invalid <> adMetadata["times"] 
adOpportunities = m.adTimesToAd(adMetadata)
else if invalid <> adMetadata["tags"]
adOpportunities = m.adTagsToAd(adMetadata)
end if
rafBreaks = []
for each item in adMetadata["breaks"].items()
ab = item.value
if ab["adCount"] <> ab.ads.count()
end if
ab.delete("adCount")
idx = 0
for each ad in ab.ads
if invalid = ad
ab.ads[idx] = {adid: invalid,duration: 0,streamFormat: "",adServer: "",streams: [],tracking: []}
end if
idx += 1
end for
if 0 < ab.ads.count()
rafBreaks.push(ab)
end if
end for
rafBreaks.sortBy("renderTime")
if invalid <> adMetadata["times"] and 1 < rafBreaks.count() 
lastPod = rafBreaks[0]
pods = [lastPod]
for i=1 to rafBreaks.count()-1
pod = rafBreaks[i]
if 1 = pod.ads.count() and abs(pod.renderTime - (lastPod.renderTime + lastPod.duration)) < 1
lastPod.ads.push( pod.ads[0] )
lastPod.duration = (pod.renderTime + pod.duration) - lastPod.renderTime
else
pods.push(pod)
lastPod = pod
end if
end for
rafBreaks = pods
end if
return {adOpportunities:adOpportunities, adBreaks:rafBreaks}
end function
impl.RGX_ADSEQ = createObject("roRegEx", "<Ad[^>]+(sequence=""(\d+)"")", "")
impl.patchVastSequence = function(vastxml as string) as string
mtch = m.RGX_ADSEQ.match(vastxml)
if invalid <> mtch and 1 < mtch.count()
sequence = mtch[1]
vastxml = vastxml.replace(sequence, "sequence=""1""")
end if
return vastxml
end function
impl.adTagsToAd = function(adMetadata as object) as integer
adOpportunities = 0
ad2id3 = {}
for each item in adMetadata["tags"].items()
if "start" = item.value["type"]
ad2id3[item.value["ad"]] = item.key
end if
end for
for each item in adMetadata["ads"].items()
breakId = item.value["break"]
ab = adMetadata["breaks"][breakId]
if invalid <> ab
index = item.value["position"] - 1
if 0 <= index
adId = item.key
item.value["vast"] = m.patchVastSequence(item.value["vast"])
rAd = m.parseAd(adId, item.value, invalid)
if invalid <> rAd and index < ab["adCount"]
ab.ads[index] = rAd
id3 = ad2id3[adId]
rAd["id3"] = id3
if 0 = index and invalid <> id3
ab["id3"] = id3
end if
adOpportunities += 1
end if
end if
end if
end for
return adOpportunities
end function
impl.adTimesToAd = function(adMetadata as object) as integer
adOpportunities = 0
ad2Start = {}
for each item in adMetadata["times"].items()
for each tm in item.value
if "start" = tm["type"]
adId = tm["ad"]
breakId = adMetadata["ads"][adId]["break"]
ad2Start[adId] = val(item.key, 10)
end if
end for
end for
for each item in adMetadata["ads"].items()
breakId = item.value["break"]
ab = adMetadata["breaks"][breakId]
if invalid <> ab
index = item.value["position"] - 1
if 0 <= index
item.value["vast"] = m.patchVastSequence(item.value["vast"])
rAd = m.parseAd(item.key, item.value, ad2Start)
if invalid <> rAd and index < ab["adCount"]
ab.ads[index] = rAd
if 0 = index
ab["renderTime"] = ad2Start[item.key]
end if
adOpportunities += 1
end if
end if
end if
end for
return adOpportunities
end function
impl.parseAd = function(adId as string, gAd as object, ad2Start as object) as object
rafAd = invalid
adIface = m.sdk.getRokuAds()
obj = adIface.parser.parse(gAd["vast"], "") 
if invalid <> obj and invalid <> obj["adopportunities"] and obj.adopportunities = 1
rafBreak = obj.adpods[0]
if invalid <> rafBreak["ads"]
rafAd = rafBreak.ads[0]
end if
end if
if invalid <> rafAd and invalid <> ad2Start and invalid <> ad2Start[adId]
m.sdk.setTrackingTime(ad2Start[adId], rafAd)
end if
return rafAd
end function
impl.parsePing = function() as void
jsn = m.loader.getPingResponse()
if invalid <> jsn and "" <> jsn
pingInfo = parsejson(jsn)
if pingInfo <> invalid
m.pingInfo = pingInfo
end if
end if
end function
impl.onMessageLIVE = function(msg as object, curAd as object) as void
posSec = msg.getData()
if m.streamManager.pastLastAdBreak(posSec)
m.streamManager.createTimeToEventMap(invalid)
end if
if invalid <> m.pingInfo
m.pingInfo["ads"] = invalid
end if
m.parsePing()
if invalid <> m.pingInfo and invalid <> m.pingInfo["ads"]
m.setRAFAdPods()
end if
if m.shouldPing(posSec)
m.loader.ping({position:posSec})
m.last_ping = createObject("roDateTime").asSeconds()
end if
end function
impl.PING_INTERVAL = 10
impl.last_ping = -1    
impl.shouldPing = function(posSec as float) as boolean
if m.last_ping < 0  or  m.loader.hasPinged() then return false
if invalid <> m.prplyInfo["time_events_url"] then return false
itis = createObject("roDateTime").asSeconds()
return (m.last_ping + m.PING_INTERVAL < itis)
end function
strmMgr = rafssai["streamManager"]
strmMgr.TXXX = "TXXX"     
strmMgr.PTS = "_decodeInfo_pts"
strmMgr.pendingPodDict = {}
strmMgr.addPendingPods = function(pods as object) as void
for each pod in pods
pod["rendersequence"] = "midroll"
m.pendingPodDict[pod["id3"]] = pod
end for
end function
strmMgr.ADS_COUNT = 16    
strmMgr.SLICE_SIZE = 4.096
strmMgr.onMetadata = function(msg as object) as object
ret = {shortDuration:false, pendingPod:invalid}
if "timedMetaData" <> msg.getField() then return ret
if invalid <> m.currentAdBreak then return ret
obj = msg.getData()
if invalid = obj[m.TXXX] or "" = obj[m.TXXX] then return ret
id3tag = obj[m.TXXX]
pendingPod = m.pendingPodDict[id3tag]
if invalid = pendingPod
pendingPod = m.findPodInStream(id3tag)
end if
if invalid <> pendingPod
pendingPod.renderTime = obj[m.PTS]
timeOffset = pendingPod.renderTime
for each ad in pendingPod.ads
m.sdk.setTrackingTime(timeOffset, ad)
timeOffset += ad.duration
end for
pendingPod.duration = timeOffset - pendingPod.renderTime
ret["pendingPod"] = pendingPod
m.pendingPodDict.delete(id3tag)
end if
return ret
end function
strmMgr.findPodInStream = function(id3tag as string) as object
pendingPod = invalid
for each item in m.pendingPodDict.items()
pod = item.value
for each ad in pod.ads
if id3tag = ad["id3"]
pendingPod = pod
exit for
end if
end for
if invalid <> pendingPod exit for
end for
if invalid <> pendingPod
for i=0 to pendingPod.ads.count()-1
if id3tag = pendingPod.ads[i]["id3"]
exit for
else
pendingPod.ads[i] = {adid: invalid,duration: 0,streamFormat: "",adServer: "",streams: [],tracking: []}
end if
end for
end if
return pendingPod
end function
impl.createLoader = function(live_or_vod as string) as object
if m.sdk.StreamType.LIVE = live_or_vod
m.last_ping = 0 
end if
obj = m.sdk.createDAIObject("liveloader")
obj.pingURL = invalid
obj.isPinging = false
obj.pingPort = createObject("roMessagePort")
obj.ping_json = invalid
obj.lastEndTs = 0
obj.dateTime = createObject("roDateTime")
baseobj = m.sdk["vodloader"]
obj.getJSON = baseobj.getJSON
obj.isValidString = baseobj.isValidString
return obj
end function
liveloader = rafssai["liveloader"]
liveloader.VODBASE  = "https://dai.google.com/ondemand/hls/content"
liveloader.LIVEBASE = "https://pubads.g.doubleclick.net/ssai/event"
liveloader.requestPreplay = function(requestObj as object) as dynamic
params = {}
if invalid <> requestObj["contentSourceId"]
params["url"] = [m.VODBASE, requestObj["contentSourceId"], "vid", requestObj["videoId"], "streams"].join("/")
else if invalid <> requestObj["assetKey"]
params["url"] = [m.LIVEBASE, requestObj["assetKey"], "streams"].join("/")
end if
requestObj["url"] = params["url"]
if invalid <> requestObj["authToken"]
params["headers"] = {Authorization:"DCLKDAI token=" + chr(34) + requestObj["authToken"] + chr(34)}
else if invalid <> requestObj["apiKey"]
params["headers"] = {Authorization:"DCLKDAI key=" + chr(34) + requestObj["apiKey"] + chr(34)}
end if
params["body"] = m.composeRequestBody(requestObj)
return m.getJSON(params)
end function
liveloader.composeRequestBody = function(requestObj as object) as string
params = createObject("roArray", 10, true)
di = createObject("roDeviceInfo")
adIface = m.sdk.getRokuAds()
params.push("rdid="+ adIface.util.getTrackingId())
params.push("idtype=rida")
params.push("is_lat=" + adIface.util.isTrackingIdDisabled())
params.push("submodel=" + di.getModel())
if invalid <> requestObj["streamActivityMonitorId"]
params.push("dai-sam-id=" + requestObj["streamActivityMonitorId"])
end if
if invalid <> requestObj["ppid"]
cf = createObject("roRegex", "ppid=", "")
if invalid = cf.isMatch(requestObj["adTagParameters"])
params.push("ppid=" + requestObj["ppid"])
end if
end if
if invalid <> requestObj["adTagParameters"]
params.push(requestObj["adTagParameters"])
end if
ai = createObject("roAppInfo")
title = ai.getTitle()
if title <> invalid and title <> ""
ut = createObject("roUrlTransfer")
params.push("an=" + ut.escape(title))
end if
appId = ai.getId()
if invalid <> appId and "" <> appId
params.push("msid=" + appId)
end if
params.push("frm=0")
params.push("correlator=" + rnd(32767).tostr())
return params.join("&")
end function
liveloader.ping = function(params as dynamic) as void
url = m.pingURL
if invalid = url and invalid <> params then url = params["url"]
if invalid = url then return
m.pingXfer = m.sdk.createUrlXfer(m.sdk.httpsRegex.isMatch(url))
m.pingXfer.setMessagePort(m.pingPort)
m.pingXfer.setUrl(url)
m.pingXfer.addHeader("Accept", "application/json")
m.pingXfer.asyncGetToString()
m.isPinging = true
end function
liveloader.hasPinged = function() as boolean
return m.isPinging
end function
liveloader.getPingResponse = function() as string
res = ""
if not m.isPinging then return res
msg = m.pingPort.getMessage()
if invalid <> msg and type(msg) = "roUrlEvent"
hstat = msg.getResponseCode()
if 200 = hstat or 201 = hstat
res = msg.getString()
else
end if
m.isPinging = false
end if
return res
end function
liveloader.composePingURL = function(prplyInfo as object) as void
if invalid <> prplyInfo["id3_events_url"] 
m.pingURL = prplyInfo["id3_events_url"]
end if
end function
return rafssai
end function
function RAFX_SSAI(params as object) as object
    if invalid <> params and invalid <> params["name"]
        p = RAFX_getGglDAIAdapter(params)
        p["__version__"] = "0b.34.5"
        p["__name__"] = params["name"]
        return p
    end if
end function
